
local TiF = CreateFrame("Frame", "StatBlock_TimeInFight")
TiF.obj = LibStub("LibDataBroker-1.1"):NewDataObject("TimeInFight", {type = "data source", value = "00:00", suffix = "TiF", text = "00:00 TiF"})
LibStub("AceTimer-3.0"):Embed(TiF)

local floor = math.floor
local mod = mod
local format = string.format
local time = time

local L_TIF = "Longest Fight"

--[[local L = GetLocale()
if L == "frFR" then
	L_TIF = "Longest Fight"
end]]

TiF:RegisterEvent("PLAYER_REGEN_ENABLED")
TiF:RegisterEvent("PLAYER_REGEN_DISABLED")
TiF:SetScript("OnEvent", function(self, event)
	self[event](self)
end)

local handle
local infight = 0
function TiF:PLAYER_REGEN_ENABLED()
	self:CancelTimer(handle, true)
	handle = nil
	local t = time() - infight
	if t > (StatBlock_TimeInFightDB or 0) then
		StatBlock_TimeInFightDB = t
	end
end

function TiF:PLAYER_REGEN_DISABLED()
	infight = time()
	handle = self:ScheduleRepeatingTimer("Update", 1)
end

local txt = "%02d:%02d"
function TiF:Update()
	local t = time() - infight
	local showTime
	local s = floor(t)
	s = mod(s, 86400)
	local h = floor(s / 3600)
	s = mod(s, 3600)
	local m = floor(s / 60)
	s = mod(s, 60)

	if h == 0 then
		showTime = format(txt, m, s)
	else
		showTime = format("%02d:%02d:%02d", h, m, s)
	end

	self.obj.text = showTime.." TiF"
	self.obj.value = showTime
end

function TiF.obj.OnTooltipShow(tooltip)
	if not tooltip or not tooltip.AddDoubleLine then return end
	tooltip:AddDoubleLine(L_TIF, SecondsToTime(StatBlock_TimeInFightDB or 0), 1, 1, 0, 0, 1, 1)
end

